import base
import utils
import os


DEPENDS = """
dev-util/subversion
gnuwin32/patch
gnuwin32/sed
dev-util/cmake
dev-util/mingw
"""

# FIXME create dbus-1d lib for qt to link against...

class subclass(base.baseclass):
  def __init__(self):
    base.baseclass.__init__( self, "" )

  def unpack( self ):
    print "windbus unpack called"
    # do the svn fetch/update
    repo = "https://windbus.svn.sourceforge.net/svnroot/windbus/trunk/"
    svndir = os.path.join( self.downloaddir, "svn-src", "windbus" )
    utils.svnFetch( repo, svndir )

    utils.cleanDirectory( self.workdir )

    # now copy the tree below destdir/trunk to workdir
    srcdir = os.path.join( svndir, "trunk" )
    destdir = os.path.join( self.workdir, "windbus" )
    utils.copySrcDirToDestDir( srcdir, destdir )

    os.chdir( destdir )
    os.system( "patch -p0 < DBus-win32.patch" )

    # for some reason windbus compiles for me only with this patch...

    file = r"cmake\bus\CMakeLists.txt"		
    os.rename( file, "%s.orig" % file )

    xmlstring = r"-L%s/win32libs/bin -lxml2" % self.rootdir.replace( "\\", "/" )
    sedcommand = r""" "s!\(\${XML_LIBRARY}\)!\1 %s!" """ % xmlstring 		

    command = "type %s.orig | sed -e %s > %s" % ( file, sedcommand, file )
    print "command:", command
    os.system( command )

    return True


  def compile( self ):
    print "windbus compile called"
    os.chdir( self.workdir )

    os.mkdir( "windbus-build" )
    os.chdir( "windbus-build" )
    #os.system( r"""cmake -G "MinGW Makefiles" ..\windbus\cmake\ -DDBUS_BUILD_TESTS=OFF -DLIBXML2_LIBRARIES=e:\kderoot\win32libs\bin\libxml2 -DLIBXML2_INCLUDE_DIR=e:\kderoot\win32libs\include""" )
    options = ""
    options = "-DCMAKE_INSTALL_PREFIX=%s/dbus " % self.cmakeInstallPrefix 
    options = options + "-DLIBXML2_LIBRARIES=%s/win32libs/bin " % self.rootdir
    options = options + "-DLIBXML2_INCLUDE_DIR=%s/win32libs/include " % self.rootdir
    cmakecommand = r"""cmake -G "MinGW Makefiles" ..\windbus\cmake\ %s""" % options
    print "cmakecommand:", cmakecommand
    os.system( cmakecommand )
    os.system( "mingw32-make" )
    return True

  def install( self ):
    print "windbus install called"
    os.chdir( os.path.join( self.workdir, "windbus-build" ) )
    os.system( "mingw32-make DESTDIR=%s install" % self.imagedir )
    utils.fixCmakeImageDir( self.imagedir, self.rootdir )
    return True


subclass().execute()
